
-module(fsm1).
-compile([export_all]).

go() ->  
   {ok, W} = io:read("type input as atoms in a list: "),
   io:fwrite("Input word: ~p ~n",[W]),
   % start up the state processes
   register(sa, spawn(?MODULE,stateA,[])),
   register(sb, spawn(?MODULE,stateB,[])),
   register(sx, spawn(?MODULE,stateX,[])),
   Start = sx,  % start state is X
   Final = sx,  % accepting state is X
   fire(Start,W).

clean() -> unregister(sa) ,unregister(sb) ,unregister(sx) .

fire(_, []) -> clean(), accept;

fire(CS,[H|RestOfInput]) ->
   %io:fwrite("char: ~p ~n",[H]),
   CS ! {self(),H}, 
   timer:sleep(1000),
   receive
      {NextState} -> fire(NextState,RestOfInput); % keep going
      M -> io:fwrite("Error: Bad Input ~p~n",[M]) % halt
   end.

stateX() ->
   receive
      {Pid, a} -> 
         io:fwrite("in X, ~p~n",[a]),
	 Pid ! {sa},
	 stateX();
      {Pid, b} -> 
         io:fwrite("in X, ~p~n",[b]),
	 Pid ! {sb},
	 stateX();
      M -> 
         io:fwrite("in X, ~p~n",[M]),
	 exit(self(),bad_input)
   end.

stateA() ->
   receive
      {Pid, a} -> 
         io:fwrite("in A, ~p~n",[a]),
	 Pid ! {sx},
	 stateA();
      M -> 
         io:fwrite("in A, ~p~n",[M]),
	 exit(self(),bad_input)
   end.

stateB() ->
   receive
      {Pid, b} -> 
         io:fwrite("in B, ~p~n",[b]),
	 Pid ! {sx},
	 stateB();
      M -> 
         io:fwrite("in B, ~p~n",[M]),
	 exit(self(),bad_input)
   end.

