-module(fsm2).
-compile([export_all]).

go() ->  
   {ok, W} = io:read("type input as atoms in a list: "),
   register(sa, spawn(?MODULE,stateA,[])),
   register(sb, spawn(?MODULE,stateB,[])),
   register(sx, spawn(?MODULE,stateX,[])),
   Start = sx,  % start state is X
   Final = sx,  % accepting state is X
   sx!W. % send the input to the start state 

stateX() ->
   receive
      [] -> 
         io:fwrite("in X, end of input, so accept~n"),
	 clean(), accept;
      [a|Rest] -> 
         io:fwrite("in X, ~p~n",[a]),
	 timer:sleep(1000),
	 sa! Rest,
	 stateX();
      [b|Rest] -> 
         io:fwrite("in X, ~p~n",[b]),
	 timer:sleep(1000),
	 sb ! Rest,
	 stateX();
      M -> 
         io:fwrite("in X, ~p, fail~n",[M]),
	 clean(),
	 exit(self(),bad_input)
   end.

stateA() ->
   receive
      [a|Rest] -> 
         io:fwrite("in A, ~p~n",[a]),
	 timer:sleep(1000),
	 sx ! Rest,
	 stateA();
      M -> 
         io:fwrite("in A, ~p, fail~n",[M]),
	 clean(),
	 exit(self(),bad_input)
   end.

stateB() ->
   receive
      [b|Rest] -> 
         io:fwrite("in B, ~p~n",[b]),
	 timer:sleep(1000),
	 sx ! Rest,
	 stateB();
      M -> 
         io:fwrite("in B, ~p, fail~n",[M]),
	 clean(),
	 exit(self(),bad_input)
   end.

clean() -> unregister(sa) ,unregister(sb) ,unregister(sx) .
